#include "Sound.h"

LPDIRECTSOUND8 CSound::pDSound = NULL;

void CSound::CreateDirectSound(HWND hWnd)
{
	DirectSoundCreate8(&DSDEVID_DefaultPlayback, &pDSound, NULL);
	pDSound->SetCooperativeLevel(hWnd, DSSCL_PRIORITY);
}

void CSound::ReleaseDirectSound()
{
	RELEASE(pDSound);
}

void CSound::Reset()
{
	pDSBuffer = NULL;
	pDSNotify = NULL;
	hEvent = NULL;
}

CSound::CSound()
{
	Reset();
}

CSound::CSound(LPCTSTR filename)
{
	Reset();
	Load(filename);
}

CSound::~CSound()
{
	if(hEvent) CloseHandle(hEvent);
	RELEASE(pDSNotify);
	RELEASE(pDSBuffer);
}

CSound::CSound(const CSound &s)
{
	Reset();
	if(pDSound) pDSound->DuplicateSoundBuffer(s.pDSBuffer, &pDSBuffer);
}

CSound& CSound::operator =(const CSound &s)
{
	// ̃f[^
	RELEASE(pDSBuffer);

	Reset();
	if(pDSound) pDSound->DuplicateSoundBuffer(s.pDSBuffer, &pDSBuffer);

	return *this;
}

BOOL CSound::Load(LPCTSTR filename)
{
	// wavet@CJ
	FILE *fp;
	if(_tfopen_s(&fp, filename, _T("rb"))){
		DXTRACE_MSG(_T("t@CJ܂"));
		return FALSE;
	}

	// {wavet@Cǂׂ
	char buf[10];
	fread(buf, 4, 1, fp);
	if(memcmp(buf, "RIFF", 4) != 0){
		DXTRACE_MSG(_T("RIFFtH[}bgł͂܂"));
		return FALSE;
	}

	// RIFFf[^TCY͏ȗ
	fseek(fp, 4, SEEK_CUR);

 	fread(buf, 8, 1, fp);
	if(memcmp(buf, "WAVEfmt ", 8) != 0){
		DXTRACE_MSG(_T("WAVEtH[}bgł͂ȂAtH[}bg`܂B"));
		return FALSE;
	}

	// fmtf[^TCYGAǂݔ΂
	fseek(fp, 4, SEEK_CUR);

    // tH[}bg擾
	WAVEFORMATEX wavf;
	fread(&wavf, sizeof(WAVEFORMATEX) - 2, 1, fp);

	// yf[^̊JnӖudatav̕񂪂邩ׂ
	ZeroMemory(buf, 10);
	while(strcmp("data", buf)){
		buf[0] = fgetc(fp);
		if(buf[0] == EOF){
			DXTRACE_MSG(_T("g`f[^`܂B"));
			fclose(fp);
			return FALSE;
		}
		if(buf[0] == 'd') fread(&buf[1], 1, 3, fp);
	}

	// yf[^TCY擾
	int wsize;
	fread(&wsize, sizeof(int), 1, fp);

	// CreateSoundBufferɑM邽߂̉y쐬
	DSBUFFERDESC desc;
	ZeroMemory(&desc, sizeof(DSBUFFERDESC));
	desc.dwSize = sizeof(DSBUFFERDESC);
	desc.dwFlags = DSBCAPS_LOCDEFER | DSBCAPS_CTRLPAN | DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLPOSITIONNOTIFY;
	desc.dwBufferBytes = wsize;
	desc.lpwfxFormat = &wavf;

	RELEASE(pDSBuffer);
	pDSound->CreateSoundBuffer(&desc, &pDSBuffer, NULL);

    //ANZX\ȃobt@̃TCY
    DWORD  buff_size;
    //WAVobt@ANZX|Cgi[ׂ̃|C^
    LPVOID pvAudioPtr;

	// obt@bN
	pDSBuffer->Lock(0, 0,			// obt@ŜbN邽߁Al̎w͕sv
		&pvAudioPtr, &buff_size,	// ރobt@擾邽߂̃|C^
		NULL, NULL,					// 2ɕďނƂł
		DSBLOCK_ENTIREBUFFER		// obt@ׂĂbN
		);

	//TEhf[^obt@֏
	fread(pvAudioPtr, buff_size, 1, fp);

	//bN
	pDSBuffer->Unlock(pvAudioPtr, buff_size, NULL, NULL);

	fclose(fp);

	return TRUE;
}

struct PlayThreadData
{
	HANDLE hEvent;
	CSound *soundobj;
};

void CSound::Play()
{
	if(pDSBuffer){
		pDSBuffer->SetCurrentPosition(0);
		pDSBuffer->Play(0, 0, 0);

		if(pDSNotify){
			// ĐIĎXbh𗧂グ
			PlayThreadData *data = new PlayThreadData;
			data->hEvent = hEvent;
			data->soundobj = this;
			DWORD threadID;
			CreateThread(NULL, 0, CSound::NotifyFunction, data, 0, &threadID);
		}
	}
}

void CSound::Stop()
{
	if(pDSBuffer) pDSBuffer->Stop();
}

void CSound::SetVolume(LONG volume)
{
	if(pDSBuffer) pDSBuffer->SetVolume(volume);
}

void CSound::SetPan(LONG lPan)
{
	if(pDSBuffer) pDSBuffer->SetPan(lPan);
}

void CSound::EnableDeleteByEnd()
{
	if(pDSBuffer == NULL) return;

	// IDirectSoundNotify̍쐬
	HRESULT hr = pDSBuffer->QueryInterface
		(IID_IDirectSoundNotify, (LPVOID*)&pDSNotify);
	
	// ʒmCxgɎgpnh̍쐬
	hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	// CxgɊւ쐬
	DSBPOSITIONNOTIFY pn;
	pn.dwOffset = DSBPN_OFFSETSTOP;	// I܂ōĐ
	pn.hEventNotify = hEvent;		// nh֘AÂ

	// Cxgf[^o^
	pDSNotify->SetNotificationPositions(1, &pn);
}

DWORD CSound::NotifyFunction(LPVOID param)
{
	PlayThreadData *data = (PlayThreadData*)param;

	// ĐIʒm܂őҋ@
	WaitForMultipleObjects(1, &data->hEvent, FALSE, INFINITE);

	// IΏۂ̃IuWFNg폜
	delete data->soundobj;

	delete data;

	return 0L;
}